//+------------------------------------------------------------------+
//|                                                     .mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <WinUser32.mqh>
extern double  lot         = 1;                          
extern int     taymfreym   = 0 ;                           
extern double  stoplos     = 200 ;                          
extern double  takeprofit  = 500 ; 
extern int     magicnumber = 350;
extern int     ControlBar  = 1;      //                            

double         gd_SL, gd_TP, gda_Price[2];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
    Print ("   ");
    gd_SL = stoplos * Point;
    gd_TP = takeprofit * Point;
//----
    return (0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   
//----
    return (0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
    double strela1 = iCustom (NULL, taymfreym, "", 2, ControlBar),
           strela2 = iCustom (NULL, taymfreym, "", 3, ControlBar);
    int    li_MyOrders[] = {0,0}, li_total = OrdersTotal(), li_Suignal = -1,
           type, li_CNT = 1, li_cnt = 1;
    datetime ldt_BeginBar = iTime (NULL, taymfreym, 0);
    static datetime ldt_NewBar = 0;
//----
    if (ldt_NewBar == ldt_BeginBar) return (0);
    ldt_NewBar = ldt_BeginBar;
    Print ("  strela1 " , strela1 , " | strela2  " , strela2);
    if (li_total > 0)
    {
        for (int i = li_total - 1; i >= 0; i--)
        {  
            if (!OrderSelect (i, SELECT_BY_POS)) continue;  //   
            if (OrderSymbol() != Symbol()) continue;            //   . 
            if (OrderMagicNumber() != magicnumber) continue;
            type = OrderType();
            if (type > 1) continue;
            li_MyOrders[type]++;
        }
    }
    if (strela1 < strela2) li_Suignal = 0; else if (strela1 > strela2) li_Suignal = 1;
    if (li_Suignal != -1)
    {
        if (li_Suignal == 1) {li_cnt = -1; li_CNT = 0;}
        RefreshRates();
        gda_Price[0] = Bid;
        gda_Price[1] = Ask;
        if (li_MyOrders[li_CNT] > 0) udalenie (li_CNT);
        if (li_MyOrders[li_Suignal] == 0)
        {
            double ld_SL, ld_TP;
            ld_SL = NormalizeDouble (gda_Price[li_Suignal] - li_cnt * gd_SL, Digits);
            ld_TP = NormalizeDouble (gda_Price[li_Suignal] + li_cnt * gd_TP, Digits);
            OrderSend (Symbol(), li_Suignal, lot, NormalizeDouble (gda_Price[li_CNT], Digits), 3, ld_SL, ld_TP, NULL, magicnumber, 0, CLR_NONE);           
            Print ("Error ", GetLastError(), ":  Price ", gda_Price[li_CNT], " | stoplos = ", ld_SL, " | takeprofit = ", ld_TP);
        }
    }
    BreakPoint();     
//----
    return (0);
}
//+------------------------------------------------------------------+
void udalenie (int Type = -1)
{
    int    type, total = OrdersTotal();
//----
    for (int i = total - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS)) continue;
        if (OrderSymbol() != Symbol()) continue;      //   . 
        if (OrderMagicNumber() != magicnumber) continue;
        type = OrderType();
        if (type > 1) continue;
        if (Type > -1) if (Type != type) continue;
        if (!OrderClose (OrderTicket(), OrderLots(), gda_Price[type], 3, CLR_NONE ))
        {
            int error =  GetLastError(); 
            string errorcomment = "   " + OrderTicket() + " " + Symbol() + " " + OrderType() + " " + error; 
            Print (errorcomment);
        }
    }       
//----
}
//+------------------------------------------------------------------+
void BreakPoint()
{//if (!IsVisualMode()) return(0);
    keybd_event (19,0,0,0);
    Sleep (10);
    keybd_event (19,0,2,0);
}
//+------------------------------------------------------------------+

